//
// C++ Interface: filelog
//
// Description: 
//
//
// Author: Arsenij Vodjanov <arsenij@gmail.com>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef FILELOG_H_
#define FILELOG_H_

#include "log.h"
#include <iostream>
#include <fstream>

//! Log implementation that logs to a file.
class FileLog : public Log
{
public:
    FileLog();

    virtual void info(const boost::format& fmt);
    virtual void error(const boost::format& fmt);
    virtual void warn(const boost::format& fmt);
    virtual void debug(const boost::format& fmt,int level=1);

    virtual ~FileLog();
private:
	std::ofstream fos;
};

#endif
