//
// C++ Implementation: globalusermodel
//
// Description: 
//
//
// Author: Rikard Bjorklind <olof@users.sourceforge.net>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "globalusermodel.h"

GlobalUserModel::GlobalUserModel(QObject *parent)
 : QObject(parent)
{
}


GlobalUserModel::~GlobalUserModel()
{
}

User* GlobalUserModel::getUser( int id )
{
	if( userMap.contains(id) ) return userMap[id];
	return NULL;
}

void GlobalUserModel::usersUpdated( int , QList<User *> ulst)
{
	for(int i=0;i < ulst.size();i++)
	{
		User* u = ulst[i];
		userMap[u->id] = u;
	}
}

void GlobalUserModel::userRemoved( int , int userid)
{
	userMap.remove( userid);
}

void GlobalUserModel::sessionInfo( int , const QString &, const QString &, const QList< User * > ulst )
{
	for(int i=0;i < ulst.size();i++)
	{
		User* u = ulst[i];
		userMap[u->id] = u;
	}	
}
