//
// C++ Interface: QueueItem
//
// Description: 
//
//
// Author: Rikard Björklind <olof@linux.nu>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef QUEUE_ITEM_H__
#define QUEUE_ITEM_H__

//! Represents an item in the transfer queue.
class QueueItem
{
public:
	int id;   				//!< Internal ID
	QString target;			//!< Target file name
	qint64 size;			//!< File size
	qint64 downloadedBytes; //!< Number of bytes downloaded so far
	int status;				//!< Transfer state
	int priority;			//!< DC++ Priority
	int currentSource;		//!< User ID of who we are downloading from
	QList<int> sources;     //!< List of other User IDs
};   


#endif
