#ifndef USER_H__
#define USER_H__

#include "global.h"
#include "blockallocator.h"

#include <QString>
using namespace std;

class User : public BlockAllocator<User>
{
  
	enum {
    OP_BIT,
    ONLINE_BIT,
    DCPLUSPLUS_BIT,
    PASSIVE_BIT,
    QUIT_HUB_BIT,
    HIDDEN_BIT,
    HUB_BIT,
    BOT_BIT
  };
	public:
  enum {
    OP = 1<<OP_BIT,
    ONLINE = 1<<ONLINE_BIT,
    DCPLUSPLUS = 1<<DCPLUSPLUS_BIT,
    PASSIVE = 1<<PASSIVE_BIT,
    QUIT_HUB = 1<<QUIT_HUB_BIT,
    HIDDEN = 1<<HIDDEN_BIT,
    HUB = 1<<HUB_BIT,
    BOT = 1<<BOT_BIT
  };

  int id;
  QString nick;
  int flags;
  QString email;
  QString description;
  QString connection;
  QString tag;
  qint64 shared;
  int numSlots;
  int index;
};

#endif
